import { ModalFormData } from "@minecraft/server-ui"
import { world, system } from "@minecraft/server"
import { mMenu } from "./main_menu.js"


class CheatMenu {
    AdminOptions(player) {
        const gamemode = player.getDynamicProperty("mode")
        const isDisabled = player.getDynamicProperty("isDisabled")
        const form = new ModalFormData()
            .title("Admin Options")
            .toggle("Reset Cheat Menu")
            .toggle("Disable Cheat Menu", isDisabled)
            .dropdown("Game Mode", ["Survival", "Creative", "Adventure", "Spectator"], gamemode)

        form.show(player).then((data) => {
            if (data.canceled) {
                mMenu.ButtonMenu(player)
                return
            }
            // RESET CHEAT MENU
            for (const player of world.getPlayers({ excludeTags: ["admin"] })) {
                if (data.formValues[0] === true) {
                    player.clearDynamicProperties()
                    player.removeEffect("instant_health")
                    player.removeEffect("haste")
                    player.removeEffect("speed")
                    player.removeEffect("jump_boost")
                    player.removeEffect("water_breathing")
                    player.removeEffect("saturation")
                    player.setDynamicProperty("health", false)
                    player.setDynamicProperty("break", false)
                    player.setDynamicProperty("speed", false)
                    player.setDynamicProperty("jump", false)
                    player.setDynamicProperty("water", false)
                    player.setDynamicProperty("kills", false)
                    player.setDynamicProperty("field", false)
                    player.setDynamicProperty("hunger", false)
                    player.setDynamicProperty("nightVision", false)
                    player.setDynamicProperty("itemMagnet", false)
                    player.removeTag("killer")
                    player.removeTag("unbreaking")
                    if (player.getDynamicProperty("intervalID") != null) {
                        system.clearRun(player.getDynamicProperty("intervalID"))
                    }
                    if (player.getDynamicProperty("magnetInterval") != null) {
                        system.clearRun(player.getDynamicProperty("magnetInterval"))
                    }
                }
            }
            // DISABLE CHEAT MENU
            for (const player of world.getPlayers()) {
                if (data.formValues[1] === true) {
                    player.setDynamicProperty("isDisabled", true)
                }
                if (data.formValues[1] === false) {
                    player.setDynamicProperty("isDisabled", false)
                }

            }
            // GAMEMODE
            if (data.formValues[2] === 0 && player.getDynamicProperty("mode") != 0) {
                player.runCommandAsync("gamemode survival @s")
            }
            if (data.formValues[2] === 1 && player.getDynamicProperty("mode") != 1) {
                player.runCommandAsync("gamemode creative @s")
            }
            if (data.formValues[2] === 2 && player.getDynamicProperty("mode") != 2) {
                player.runCommandAsync("gamemode adventure @s")
            }
            if (data.formValues[2] === 3 && player.getDynamicProperty("mode") != 3) {
                player.runCommandAsync("gamemode spectator @s")
            }
        })
    }
    AdminCheatMenu(player) {
        const infHealth = player.getDynamicProperty("health")
        const neverHungry = player.getDynamicProperty("hunger")
        const instaBreak = player.getDynamicProperty("break")
        const toggleSpeed = player.getDynamicProperty("speed")
        const toggleJump = player.getDynamicProperty("jump")
        const neverDrown = player.getDynamicProperty("water")
        const easyKills = player.getDynamicProperty("kills")
        const forcefield = player.getDynamicProperty("field")
        const intervalID = player.getDynamicProperty("intervalID")
        const nightVision = player.getDynamicProperty("nightVision")
        const magnet = player.getDynamicProperty("itemMagnet")
        const magnetInterval = player.getDynamicProperty("magnetInterval")
        const infDurability = player.getDynamicProperty("durability")
        const form = new ModalFormData()
            .title("Cheat Menu")
            .toggle("Infinite Health ", infHealth)
            .toggle("Never Hungry ", neverHungry)
            .toggle("Instabreak ", instaBreak)
            .toggle("Walk/Run Fast ", toggleSpeed)
            .toggle("Super Jump ", toggleJump)
            .toggle("Never Drown ", neverDrown)
            .toggle("One Hit Kills ", easyKills)
            .toggle("Force Field ", forcefield)
            .toggle("Night Vision ", nightVision)
            .toggle("Item Magnet ", magnet)
            .toggle("Infinite Durability", infDurability)
            .slider("Give XP", 0, 10000, 100, 0)
            .slider("Give XP Levels", 0, 1000, 10, 0)

        form.show(player).then((data) => {
            if (data.canceled) {
                mMenu.ButtonMenu(player)
                return
            }
            // INFINITE HEALTH
            if (data.formValues[0] === true) {
                player.setDynamicProperty("health", true)
                player.addEffect("instant_health", 20000000, { showParticles: false, amplifier: 255 })
            }
            if (data.formValues[0] === false) {
                player.setDynamicProperty("health", false)
                player.removeEffect("instant_health")
            }
            // NEVER HUNGRY
            if (data.formValues[1] === true) {
                player.setDynamicProperty("hunger", true)
                player.addEffect("saturation", 20000000, { showParticles: false, amplifier: 255 })
            }
            if (data.formValues[1] === false) {
                player.setDynamicProperty("hunger", false)
                player.removeEffect("saturation")
            }
            // INSTABREAK
            if (data.formValues[2] === true) {
                player.setDynamicProperty("break", true)
                player.addEffect("haste", 20000000, { showParticles: false, amplifier: 255 })
            }
            if (data.formValues[2] === false) {
                player.setDynamicProperty("break", false)
                player.removeEffect("haste")
            }
            // WALK/RUN FAST
            if (data.formValues[3] === true) {
                player.setDynamicProperty("speed", true)
                player.addEffect("speed", 20000000, { showParticles: false, amplifier: 20 })
            }
            if (data.formValues[3] === false) {
                player.setDynamicProperty("speed", false)
                player.removeEffect("speed")
            }
            // SUPER JUMP
            if (data.formValues[4] === true) {
                player.setDynamicProperty("jump", true)
                player.addEffect("jump_boost", 20000000, { showParticles: false, amplifier: 20 })
            }
            if (data.formValues[4] === false) {
                player.setDynamicProperty("jump", false)
                player.removeEffect("jump_boost")
            }
            // NEVER DROWN
            if (data.formValues[5] === true) {
                player.setDynamicProperty("water", true)
                player.addEffect("water_breathing", 20000000, { showParticles: false, amplifier: 255 })
            }
            if (data.formValues[5] === false) {
                player.setDynamicProperty("water", false)
                player.removeEffect("water_breathing")
            }
            // EASY KILLS
            if (data.formValues[6] === true) {
                player.setDynamicProperty("kills", true)
                if (!player.hasTag("killer")) {
                    player.addTag("killer")
                }
            }
            if (data.formValues[6] === false) {
                player.setDynamicProperty("kills", false)
                if (player.hasTag("killer")) {
                    player.removeTag("killer")
                }
            }
            // FORCE FIELD
            if (data.formValues[7] === true) {
                player.setDynamicProperty("field", true)
                if (intervalID != null) {
                    system.clearRun(intervalID)
                }
                player.setDynamicProperty("intervalID", system.runInterval(() => {
                    const playerloc = player.location
                    for (const entity of player.dimension.getEntities({ families: ["monster"], location: player.location, maxDistance: 10 })) {
                        let direction = getDirection(playerloc, entity.location)
                        entity.applyKnockback(direction.x, direction.z, 3, 0.5)
                    }
                    for (const entity of player.dimension.getEntities({ type: "minecraft:arrow", location: player.location, maxDistance: 10 })) {
                        let direction = getDirection(playerloc, entity.location)
                        entity.applyImpulse({ x: direction.x, y: direction.y, z: direction.z })
                    }
                    for (const entity of player.dimension.getEntities({ type: "minecraft:fireball", location: player.location, maxDistance: 10 })) {
                        let direction = getDirection(playerloc, entity.location)
                        entity.applyImpulse({ x: direction.x, y: direction.y, z: direction.z })
                    }
                }))
            }
            if (data.formValues[7] === false) {
                player.setDynamicProperty("field", false)
                if (intervalID != null) {
                    system.clearRun(intervalID)
                }
            }
            // NIGHT VISION
            if (data.formValues[8] === true) {
                player.setDynamicProperty("nightVision", true)
                player.addEffect("night_vision", 20000000, { showParticles: false, amplifier: 255 })
            }
            if (data.formValues[8] === false) {
                player.setDynamicProperty("nightVision", false)
                player.removeEffect("night_vision")
            }
            // ITEM MAGNET
            if (data.formValues[9] === true) {
                player.setDynamicProperty("itemMagnet", true)
                if (magnetInterval != null) {
                    system.clearRun(magnetInterval)
                }
                player.setDynamicProperty("magnetInterval", system.runInterval(() => {
                    player.runCommandAsync(`tp @e[type=item,r=10] ^ ^ ^0.0001`)
                }))
            }
            if (data.formValues[9] === false) {
                player.setDynamicProperty("itemMagnet", false)
                if (magnetInterval != null) {
                    system.clearRun(magnetInterval)
                }
            }
            // INFINITE DURABILITY
            if (data.formValues[10] === true) {
                if (!player.hasTag("unbreaking")) {
                    player.addTag("unbreaking")
                }
            }
            if (data.formValues[10] === false) {
                if (player.hasTag("unbreaking")) {
                    player.removeTag("unbreaking")
                }
            }
            // GIVE XP
            if (data.formValues[11] > 0) {
                player.addExperience(data.formValues[10].valueOf())
            }
            // GIVE XP LEVELS
            if (data.formValues[12] > 0) {
                player.addLevels(data.formValues[11].valueOf())
            }
        })
    }
    //non admin menu
    PlayerCheatMenu(player) {
        const infHealth = player.getDynamicProperty("health")
        const neverHungry = player.getDynamicProperty("hunger")
        const instaBreak = player.getDynamicProperty("break")
        const toggleSpeed = player.getDynamicProperty("speed")
        const toggleJump = player.getDynamicProperty("jump")
        const neverDrown = player.getDynamicProperty("water")
        const easyKills = player.getDynamicProperty("kills")
        const forcefield = player.getDynamicProperty("field")
        const intervalID = player.getDynamicProperty("intervalID")
        const nightVision = player.getDynamicProperty("nightVision")
        const magnet = player.getDynamicProperty("itemMagnet")
        const magnetInterval = player.getDynamicProperty("magnetInterval")
        const infDurability = player.getDynamicProperty("durability")
        const form = new ModalFormData()
            .title("Cheat Menu")
            .toggle("Infinite Health ", infHealth)
            .toggle("Never Hungry ", neverHungry)
            .toggle("Instabreak ", instaBreak)
            .toggle("Walk/Run Fast ", toggleSpeed)
            .toggle("Super Jump ", toggleJump)
            .toggle("Never Drown ", neverDrown)
            .toggle("One Hit Kills ", easyKills)
            .toggle("Force Field ", forcefield)
            .toggle("Night Vision ", nightVision)
            .toggle("Item Magnet ", magnet)
            .toggle("Infinite Durability", infDurability)
            .slider("Give XP", 0, 10000, 100, 0)
            .slider("Give XP Levels", 0, 1000, 10, 0)

        form.show(player).then((data) => {
            if (data.canceled) return;
            // INFINITE HEALTH
            if (data.formValues[0] === true) {
                player.setDynamicProperty("health", true)
                player.addEffect("instant_health", 20000000, { showParticles: false, amplifier: 255 })
            }
            if (data.formValues[0] === false) {
                player.setDynamicProperty("health", false)
                player.removeEffect("instant_health")
            }
            // NEVER HUNGRY
            if (data.formValues[1] === true) {
                player.setDynamicProperty("hunger", true)
                player.addEffect("saturation", 20000000, { showParticles: false, amplifier: 255 })
            }
            if (data.formValues[1] === false) {
                player.setDynamicProperty("hunger", false)
                player.removeEffect("saturation")
            }
            // INSTABREAK
            if (data.formValues[2] === true) {
                player.setDynamicProperty("break", true)
                player.addEffect("haste", 20000000, { showParticles: false, amplifier: 255 })
            }
            if (data.formValues[2] === false) {
                player.setDynamicProperty("break", false)
                player.removeEffect("haste")
            }
            // WALK/RUN FAST
            if (data.formValues[3] === true) {
                player.setDynamicProperty("speed", true)
                player.addEffect("speed", 20000000, { showParticles: false, amplifier: 20 })
            }
            if (data.formValues[3] === false) {
                player.setDynamicProperty("speed", false)
                player.removeEffect("speed")
            }
            // SUPER JUMP
            if (data.formValues[4] === true) {
                player.setDynamicProperty("jump", true)
                player.addEffect("jump_boost", 20000000, { showParticles: false, amplifier: 20 })
            }
            if (data.formValues[4] === false) {
                player.setDynamicProperty("jump", false)
                player.removeEffect("jump_boost")
            }
            // NEVER DROWN
            if (data.formValues[5] === true) {
                player.setDynamicProperty("water", true)
                player.addEffect("water_breathing", 20000000, { showParticles: false, amplifier: 255 })
            }
            if (data.formValues[5] === false) {
                player.setDynamicProperty("water", false)
                player.removeEffect("water_breathing")
            }
            // EASY KILLS
            if (data.formValues[6] === true) {
                player.setDynamicProperty("kills", true)
                if (!player.hasTag("killer")) {
                    player.addTag("killer")
                }
            }
            if (data.formValues[6] === false) {
                player.setDynamicProperty("kills", false)
                if (player.hasTag("killer")) {
                    player.removeTag("killer")
                }
            }
            // FORCE FIELD
            if (data.formValues[7] === true) {
                player.setDynamicProperty("field", true)
                if (intervalID != null) {
                    system.clearRun(intervalID)
                }
                player.setDynamicProperty("intervalID", system.runInterval(() => {
                    const playerloc = player.location
                    for (const entity of player.dimension.getEntities({ families: ["monster"], location: player.location, maxDistance: 10 })) {
                        let direction = getDirection(playerloc, entity.location)
                        entity.applyKnockback(direction.x, direction.z, 3, 0.5)
                    }
                    for (const entity of player.dimension.getEntities({ type: "minecraft:arrow", location: player.location, maxDistance: 10 })) {
                        let direction = getDirection(playerloc, entity.location)
                        entity.applyImpulse({ x: direction.x, y: direction.y, z: direction.z })
                    }
                    for (const entity of player.dimension.getEntities({ type: "minecraft:fireball", location: player.location, maxDistance: 10 })) {
                        let direction = getDirection(playerloc, entity.location)
                        entity.applyImpulse({ x: direction.x, y: direction.y, z: direction.z })
                    }
                }))
            }
            if (data.formValues[7] === false) {
                player.setDynamicProperty("field", false)
                if (intervalID != null) {
                    system.clearRun(intervalID)
                }
            }
            // NIGHT VISION
            if (data.formValues[8] === true) {
                player.setDynamicProperty("nightVision", true)
                player.addEffect("night_vision", 20000000, { showParticles: false, amplifier: 255 })
            }
            if (data.formValues[8] === false) {
                player.setDynamicProperty("nightVision", false)
                player.removeEffect("night_vision")
            }
            // ITEM MAGNET
            if (data.formValues[9] === true) {
                player.setDynamicProperty("itemMagnet", true)
                player.setDynamicProperty("magnetInterval", system.runInterval(() => {
                    player.runCommandAsync(`tp @e[type=item,r=10] ^ ^ ^0.0001`)
                }))
            }
            if (data.formValues[9] === false) {
                player.setDynamicProperty("itemMagnet", false)
                if (magnetInterval != null) {
                    system.clearRun(magnetInterval)
                }
            }
            // INFINITE DURABILITY
            if (data.formValues[10] === true) {
                if (!player.hasTag("unbreaking")) {
                    player.addTag("unbreaking")
                }
            }
            if (data.formValues[10] === false) {
                if (player.hasTag("unbreaking")) {
                    player.removeTag("unbreaking")
                }
            }
            // GIVE XP
            if (data.formValues[11] > 0) {
                player.addExperience(data.formValues[10].valueOf())
            }

            // GIVE XP LEVELS
            if (data.formValues[12] > 0) {
                player.addLevels(data.formValues[11].valueOf())
            }
        })
    }
}
export const Menu = new CheatMenu

// FORCE FIELD GET DIRECTION VECTOR
function getDirection(observer, destination) {
    const distanceVector = {
        x: destination.x - observer.x,
        y: destination.y - observer.y,
        z: destination.z - observer.z,
    };
    const obj = {
        x: 0, y: 0, z: 0,
        distance: 0, horizontalDistance: 0, verticalDistance: distanceVector.y,
        azimuth: 0, elevation: 0,
    };
    if (distanceVector.x !== 0 || distanceVector.y !== 0 || distanceVector.z !== 0) {
        const xSquared = distanceVector.x * distanceVector.x;
        const zSquared = distanceVector.z * distanceVector.z;
        obj.distance = Math.sqrt(xSquared + distanceVector.y * distanceVector.y + zSquared);
        obj.horizontalDistance = Math.sqrt(xSquared + zSquared);
        obj.azimuth = Math.atan(distanceVector.z / distanceVector.x) + (distanceVector.x < 0 ? Math.PI : 0);
        obj.elevation = Math.atan(distanceVector.y / obj.horizontalDistance) + (obj.horizontalDistance < 0 ? Math.PI : 0);
        const cosElevation = Math.cos(obj.elevation);
        obj.x = cosElevation * Math.cos(obj.azimuth);
        obj.y = Math.sin(obj.elevation);
        obj.z = cosElevation * Math.sin(obj.azimuth);
    }
    return obj;
}