import { world } from "@minecraft/server"
import { mMenu } from "./main_menu.js"
import { Menu } from "./cheat_menu.js"

const playersJoined = []

world.afterEvents.playerSpawn.subscribe((data) => {

    const player = data.player
    playersJoined.push(player.name)

    if (data.initialSpawn) {
        for (const permissionSave of world.getPlayers({ name: playersJoined[0] })) {
            for (const adminExists of world.getAllPlayers()) {
                if (!permissionSave.hasTag("admin") && !adminExists.hasTag("admin")) {
                    permissionSave.addTag("admin")
                }
            }
        }
    }
})

world.afterEvents.itemUse.subscribe((data) => {

    const item = data.itemStack
    const player = data.source
    const isDisabled = player.getDynamicProperty("isDisabled")

    if (item.typeId === "cheats:cheat_menu_staff" && !player.hasTag("admin") && isDisabled == false) {
        return Menu.PlayerCheatMenu(player)
    };
    if (player.hasTag("admin") && item.typeId === "cheats:cheat_menu_staff") {
        for (const gmPlayer of world.getPlayers({ gameMode: 0 })) {
            if (player.name === gmPlayer.name) {
                player.setDynamicProperty("mode", 0)
            }
        }
        for (const gmPlayer of world.getPlayers({ gameMode: 1 })) {
            if (player.name === gmPlayer.name) {
                player.setDynamicProperty("mode", 1)
            }
        }
        for (const gmPlayer of world.getPlayers({ gameMode: 2 })) {
            if (player.name === gmPlayer.name) {
                player.setDynamicProperty("mode", 2)
            }
        }
        for (const gmPlayer of world.getPlayers({ gameMode: 3 })) {
            if (player.name === gmPlayer.name) {
                player.setDynamicProperty("mode", 3)
            }
        }
        return mMenu.ButtonMenu(player)
    }
})